setwd("F:\\shengxin2\\TMB MSI\\15.TMBcor")             #ùĿ¼

#ȡļ
exp=read.table("singleGeneExp.txt", header=T,sep="\t",row.names=1,check.names=F)
#ȡTMBļ
TMB=read.table("TMB.txt", header=T,sep="\t",row.names=1,check.names=F)
#ȥƷ
group=sapply(strsplit(row.names(exp),"\\-"),"[",4)
group=sapply(strsplit(group,""),"[",1)
group=gsub("2","1",group)
exp=exp[group==0,]
#Ʒȡ
sameSample=intersect(row.names(TMB),row.names(exp))
TMB=TMB[sameSample,]
exp=exp[sameSample,]

#Լ
outTab=data.frame()
fmsbTab=data.frame()
for(i in levels(factor(exp[,"CancerType"]))){
     exp1=exp[(exp[,"CancerType"]==i),]
     TMB1=TMB[(TMB[,"CancerType"]==i),]
	 x=as.numeric(TMB1[,1])
	 y=as.numeric(exp1[,1])
	 corT=cor.test(x,y,method="spearman")
	 cor=corT$estimate
	 pValue=corT$p.value
	 sig=ifelse(pValue<0.001,"***",ifelse(pValue<0.01,"**",ifelse(pValue<0.05,"*"," ")))
	 outTab=rbind(outTab,cbind(CancerType=i,cor=cor,pValue=pValue,sig))
	 fmsbTab=rbind(fmsbTab,cbind(CancerType=i,cor=cor))
}
write.table(outTab,file="corStat.txt",sep="\t",row.names=F,quote=F)
write.table(t(fmsbTab),file="fmsbInput.txt",sep="\t",col.names=F,quote=F)

