
#install.packages("fmsb")

library(fmsb) 
setwd("F:\\shengxin2\\TMB MSI\\18.MSIradar")         #ùĿ¼
data=read.table("fmsbInput.txt",header=T,sep="\t",row.names=1,check.names=F)   #ȡļ
maxValue=ceiling(max(abs(data))*10)/10
data=rbind(rep(maxValue,ncol(data)),rep(-maxValue,ncol(data)),data)
#ɫ
colors="blue"
#
corStat=read.table("corStat.txt",header=T,sep="\t",row.names=1,check.names=F)
colnames(data)=paste0(colnames(data),corStat$sig)

#
pdf(file="radar.pdf",height=7,width=7)
radarchart( data, axistype=1 , 
    pcol=colors,                 #ɫ
    plwd=2 ,                     #
    plty=1,                      #ߣʵ
    cglcol="grey",               #ɫ
    cglty=1,                     #ߣʵ 
    caxislabels=seq(-maxValue,maxValue,maxValue/2),    #̶
    cglwd=1.2,                   #ϸ
    axislabcol="green",           #̶ɫ
    vlcex=0.8                    #С
)
dev.off()


